//	Ex442_fast.cpp

//	Sec. 4.4 of lecture
//	FOR-loop 
//			Example: double sum and (very, very) fast version
//			try  n = 5000 
//			The fast version requires at least n=100000 to measure a time != 0
//		n = 100000:	old:  381    sec
//				new:    0.01 sec

#include <iostream>
#include <ctime>          // contains clock()
using namespace std;

int main()
{
 int    i,k,n;			// loop index, sum, last index
 double sum_i,sum_k;		// outer and inner sum
 double time1=0.0, time2=0.0, time3=0.0, tstart;  // time measurement
 
 cout << endl;
 cout << "  Input n : ";
 cin  >> n;				// read n

//
//	conventional version
//
 tstart = clock();
 sum_k = 0.0;				// initialize outer sum
 
 for ( k = 1; k <= n; ++k)
  {
    sum_i = 0.0;			// initialize inner sum
    for ( i = 1; i <= k; ++i)		// last index depends on k !!
     {
        sum_i = sum_i + 1.0/i/i;
     }
 //   cout << "  Sum (" << k << ") = " << sum_i << endl;
    sum_k = sum_k + sum_i;		// sum_k grows unbounded
//    sum_k = sum_k + sum_i/n;		// sum_k is bounded
  }
 time1 += clock()-tstart;

 cout << endl;
 cout << "  a) Double-Sum (" << n << ") = " << sum_k; 
 cout << "  in  " << time1/CLOCKS_PER_SEC << " sec." <<  endl; 
 cout << endl;

//
//	fast version [Haase]
//
 tstart = clock();
 double t_k   = 0.0;
 sum_k = 0.0;
 
 for ( k = 1; k <= n; ++k)
  {
    t_k = t_k + 1.0/k/k;
 //   cout << "  Sum (" << k << ") = " << sum_i << endl;
    sum_k = sum_k + t_k;		// sum_k grows unbounded
//    sum_k = sum_k + t_k/n;		// sum_k is bounded
  }
time2 += clock()-tstart;
  
 cout << endl;
 cout << "  b) Double-Sum (" << n << ") = " << sum_k; 
 cout << "  in  " << time2/CLOCKS_PER_SEC << " sec." << endl; 
 cout << endl;
 
//
//	fast version [Hr. Andreas Reinhart]
//
 tstart = clock();
 sum_k = 0.0;
 
 for ( i = 1; i <= n; ++i)
  {
    t_k = (n-i+1.0)/i/i;
 //   cout << "  Sum (" << k << ") = " << sum_i << endl;
 
    sum_k = sum_k + t_k;		// sum_k grows unbounded
//    sum_k = sum_k + t_k/n;		// sum_k is bounded
  }
time3 += clock()-tstart;
  
 cout << endl;
 cout << "  c) Double-Sum (" << n << ") = " << sum_k; 
 cout << "  in  " << time3/CLOCKS_PER_SEC << " sec." << endl; 
 cout << endl; 
   
}
 
 
 
 
 
 
 
 
 
