//	Ex740.cpp

//	Sec. 7.4 of lecture
//	2D arrays
//	Output matrix

#include <iostream>
using namespace std;

//	global constants (for static 2D array)
const int MCOL=3;

//	Declarations
void PrintVec(const int n, const double x[]);
void PrintMat_fix(const int nrow, const double a[][MCOL]);
void PrintMat(const int nrow, const int ncol, const double a[]);

//	Definitions
//-------------------------------------------------------------------
//		Print elements of a vector (length n)
//
void PrintVec(const int n, const double x[])
{
 int i;
 
 cout << endl;
 for (i=0; i<n; ++i)
  {
   cout << "  " << x[i];
  }
 cout << endl << endl; 
 return;
}
//-------------------------------------------------------------------
//		Print elements of a matrix 
//			(nrow rows and fixed number MCOL of columns)
//
//void PrintMat_fix(const int nrow, const double a[][])	// doesn't compile
// 		doesn't help to fix that
//void PrintMat_fix(const int nrow, const int ncol, const double a[][])	
//
void PrintMat_fix(const int nrow, const double a[][MCOL])
{
 int i,j;
 
 cout << endl;
 for (i=0; i<nrow; ++i)
  {
    cout << "row " << i << ":";
    for (j=0; j<MCOL; ++j)
     {
       cout << "  " << a[i][j];
     }
    cout << endl; 
  }
 cout << endl << endl; 
 return;
}

//-------------------------------------------------------------------
//		Print elements of a matrix 
//			(nrow rows and ncol columns)
//
void PrintMat(const int nrow, const int ncol, const double a[])
{
 int i,j;
 
 cout << endl;
 for (i=0; i<nrow; ++i)
  {
    cout << "Row " << i << ":";
    for (j=0; j<ncol; ++j)
     {
       cout << "  " << a[i*ncol+j] ;
     }
    cout << endl; 
  }
 cout << endl << endl; 
 return;
}

//  ############################################################

int main()
{
 const int NROW=4;                 	// local constant
                                        // dynamic matrix a
 double a[NROW][MCOL] = {{4,-1,-0.5}, {-1,4,-1}, {-0.5,-1,4}, {3,0,-1} }, 
	u[MCOL] = {1,2,3};
 double *b;				// dynamic matrix b
 int    i,j,nrow,ncol;

//			allocate matrix b
 nrow = NROW;				// instead of input 
 ncol = MCOL;
 b = new double [NROW*MCOL];
//			copy matrix a on matrix b
 for (i=0; i<NROW; ++i) 
   for (j=0; j<MCOL; ++j) 
       b[i*MCOL+j] = a[i][j];

//			output matrices
 PrintMat_fix(NROW,a); 
 PrintMat(NROW,MCOL,a[0]);		// first row of matrix a
 PrintMat(nrow,ncol,b);

//			output vector
 PrintVec(MCOL,u); 
}
 
 
 
 
 
 
 
 
 
