//
//		Out-Of-Memory situation
//			N E W   C++ standard - using "nothrow"
//			    on LINUX: gcc-compiler
//
//			Allows to check with NULL pointer

// Literature:	Scott Meyers, Effektiv C++ programmieren, p.47ff
//		Bjarne Stroustrup, C++, p.885
//		Satir/Brown (O'Reilly), C++, p.85ff

#include <iostream>
//			New header file "new" (without suffix!!)
//				needed for "nothrow"
#include <new>
using namespace std;

int main()
{
 double *x;
    int n;
    
 cout << endl;
 cout << " Dimension of array = " ; cin >> n;
 
// x = new double[n];			// Allocate memory
//		Leads to a std:bad_alloc exeption, 
//			i.e., usually a core dump

 x = new (nothrow) double[n];		// Allocate memory
 
 cout << " ============" << endl;
 cout << " x  = " << x << endl << endl;
 
 if ( x == 0 )				// Check Out-Of-Memory
  {
    cout << " Out of Memory" << endl;
  }
 else
  {
    cout << n*sizeof(x[0]) << " Byte allocated" << endl;
    
    delete [] x;			// Deallocate memory
  }
 cout << endl;

 return 0;
}
 
 
 
 
 
 
 
 
 
