//	complex.hh
#ifndef COMPLEX_FILE
#define COMPLEX_FILE

#include <iostream>
using namespace std;

// #######################################################
//		Complex number class
// #######################################################

class Complex
{
//			Data
 private:
   double re, im;	// real an imaginary part of complex number

//			Methods
 public:
//			Standard and parameter constructor
  Complex(const double re_in = 0.0 , const double im_in = 0.0)
  	{ cout << "Parameter-Konstr." << endl;
	  re = re_in; im = im_in;};

//			Copy constructor (the same as the default)
  Complex(const Complex & orig)
  	{ cout << "Copy-Konstr." << endl;
	  re = orig.Re(); im = orig.Im(); };

//			Destructor (the same as the default)
  ~Complex() { cout << "Destruktor" << endl;
               };


//			Access Methods
  const double& Re() const {return re;};
  const double& Im() const {return im;};
        double& Re()       {return re;};
        double& Im()       {return im;};

//		Operators
//			Assignment operator:    this = orig
  Complex& operator=(const Complex & orig)
  	{ cout << "Zuweisung" << endl;
	  re = orig.Re(); im = orig.Im(); return *this;  };

//			Operator:  this += v
  Complex& operator+=(const Complex & v)
  	{ Re() += v.Re();  Im() += v.Im(); return *this;  };

//			Operator:  this * y
  Complex operator*(const Complex & y)
  	{
	  cout << " in Mult_complex_complex:  "
	  	<< y.Re() << " + " << y.Im() << "i" << endl;
	  return Complex(Re() * y.Re() - Im() * y.Im(),
	  		 Re() * y.Im() + Im() * y.Re() );
	};

//			Operator:  this *= v
   Complex& operator*=(const Complex & v)
   	{ double t=Re(), s=v.Re();	// save  b o t h   real part
	  Re() = t * s      - Im() * v.Im();
 	  Im() = t * v.Im() + Im() * s;
 	  return *this;
        };

//			tmp <--  this + y
  Complex operator+(const Complex & y);

/*
  Complex operator+(const Complex & y)
  	{
	  Complex tmp(Re()+y.Re(), Im()+y.Im());
//	  tmp.Re() =  Re()+Re();
	  return tmp;
	};
*/
//			tmp <--  this - y
 Complex operator-(const Complex & y)
  	{
	  return Complex(Re()-y.Re(), Im()-y.Im());
	};

  bool operator == (const Complex & v) const
  	{ return ( Re()==v.Re() && Im()==v.Im() ); };

//   bool operator<(const Complex & y)
// {
//   return ( Re()<y.Re() || ( Re()==y.Re() || Im()<y.Im() ) );
// };


// --------------------------------------------------------------
//		Methoden, welche eigentlich Funktionen sind
//	friend und innerhalb der Klasse ist notwendig, da
//	sonst bei mehrmaligem Einbinden des Headerfiles
//	ein "multiple definition"-Fehler angezeigt wird.
// --------------------------------------------------------------

//			Print
 friend ostream & operator<<(ostream & s, const Complex & orig)
 	{  return s << orig.Re() << " + " <<  orig.Im() << "i   "; };


//			Input
 friend istream & operator>>(istream & s, Complex & orig)
 	{  return s >> orig.Re() >>  orig.Im(); };

//			tmp <--  scal * y
 friend Complex operator*(const double & scal, const Complex & y)
  	{
	  return Complex(scal* y.Re(), scal * y.Im() );
	};
};

// Beide Varianten fuer Operator< gehen: Methode als auch Funktion !!
 inline bool operator<(const Complex & x, const Complex & y)
{
  return ( x.Re()<y.Re() || ( x.Re()==y.Re() || x.Im()<y.Im() ) );
}


#endif






















