//
#include "linalg.hpp"
#include <cassert>
#include <string>
#include <fstream>
using namespace std; 

Vektor::Vektor(const int n, const double val )
{
  nd = n;
  d = new double [nd];
  
  for (int i=0; i<nd; ++i)   d[i] = val;

  return;
}

Vektor::Vektor(const string& filename)
{
 ifstream ff( filename.c_str() );
 
 ff >> nd;
 d = new double [nd];
 
 for (int i=0; i<nd; ++i)   ff >> d[i];
 return;
}

Vektor:: Vektor(const Vektor& org)
{
  nd = org.size();
  d = new double [nd];
  
  for (int i=0; i<nd; ++i)   d[i] = org.d[i];

  return;
}

Vektor::~Vektor()
{
  delete [] d;
}


double Vektor::norm() const
{
  double s=0.0;
  for (int i=0; i<size(); ++i)
      s += d[i]*d[i];
      
  return s;
}


// quick and dirty  (unsave !!!)  ==>  see winter term
Vektor& Vektor::operator=(const Vektor& rhs)
{
// works only if both vector have the same size !!
// and memory has been allocated already
 for (int i=0; i<size(); ++i)
      d[i] = rhs.d[i];

 return *this;
}


Vektor Vektor::operator+(const Vektor& rhs)
{
 Vektor tmp(*this);

 for (int i=0; i<size(); ++i)
      tmp.d[i] += rhs.d[i];

 return tmp;
}

Vektor Vektor::operator-(const Vektor& rhs)
{
 Vektor tmp(size(),0.0); 

 for (int i=0; i<size(); ++i)
      tmp.d[i] = d[i] - rhs.d[i];

 return tmp;
}

Vektor Vektor::operator*(const Vektor& rhs)
{
 Vektor tmp(rhs); 

 for (int i=0; i<size(); ++i)
      tmp[i] *= d[i];

 return tmp;
}


ostream& operator<< ( ostream& s, const Vektor& rhs)
{
  s << "length " << rhs.size() << endl;
  for (int i=0; i<rhs.size(); ++i)
      s << rhs.d[i] << "  ";
      
  return s; 
}


Matrix::Matrix(const char filename[])
{
 ifstream ff( filename );
 
 ff >> nrow >> ncol;
 m = new double [nrow*ncol];
 // Check !? iff nrow == ncol
 assert(nrow == ncol);   //  --> C++ exception handling
 
 for (int i=0; i<nrow*ncol; ++i)   ff >> m[i];
 return;
}


Matrix::~Matrix()
{
  delete [] m;
}


Vektor Matrix::diag1()
{
 Vektor tmp(nrow,0.0);
 
 for (int i=0; i<tmp.size(); ++i)
//      tmp.d[i] =  0.0;
      tmp[i] =  1.0/m[i*ncol+i];
      
 return tmp;
}


Vektor Matrix::operator* (const Vektor& rhs)
{
 Vektor tmp(nrow,0.0);
 
 for (int i=0; i<nrow; ++i)
 {
   double s=0.0;
   for (int j=0; j<ncol; ++j)
   {
      s += m[i*ncol+j]*rhs[j];
   }
   tmp[i] = s;
 }
 

 return tmp;
}



