//
#include <string>
#include <iostream>
using namespace std;

class Vektor
{
 private:
  int nd;
  double* d;

 public:
  Vektor(const int n, const double val );
  Vektor(const std::string& filename);
  Vektor(const Vektor& org);
  
  ~Vektor(); // Destructor is needed if Memory has been allocated
  
  double norm() const;          // returns Euclidian norm
  int    size() const
            { return nd; };    // returns #elements; member of class will not be changed
  
  Vektor& operator=(const Vektor& rhs);
  Vektor  operator+(const Vektor& rhs);
  Vektor  operator-(const Vektor& rhs);
  Vektor  operator*(const Vektor& rhs);
  
   double& operator[](int i)
       { return d[i]; };          // non-const access operator
   const double& operator[](int i) const
       { return d[i]; };          // access operator

         
  friend ostream& operator<< ( ostream& s, const Vektor& rhs);
};


class Matrix
{
 private:
   int nrow, ncol;
   double* m;
   
 public:
  Matrix(const char filename[]);
  
  ~Matrix();              // Destructor is needed if Memory has been allocated
  
  Vektor diag1();
  
  Vektor operator* (const Vektor& rhs);  // Matrix times Vector

};
