//	studenten.cpp

#include <iostream>
#include <string>
#include "studenten_s.hpp"
using namespace std;

// ---------------------------------------------------------------------

Studenten :: Studenten()
: matrikel(0), skz(0), pname(""), pvorname("")
{}

// ---------------------------------------------------------------------

Studenten :: Studenten(const string& vorname, const string& name, 
		  const long int  mat_nr,    const int  skz_nr)
: matrikel(mat_nr), skz(skz_nr), pname(name), pvorname(vorname)
{
}

// ---------------------------------------------------------------------
//	Copy constructor will be applied only to uninitialized data
//	===> no deallocation of memory necessary

Studenten :: Studenten(const Studenten& orig)
: matrikel(orig.matrikel), skz(orig.skz), 
  pname(orig.pname), pvorname(orig.pvorname)
{
}

// ---------------------------------------------------------------------

Studenten :: ~Studenten()
{
}

// ---------------------------------------------------------------------
//	Assignment operator will be applied also to already initialized data
//	===> deallocation of memory may be necessary

Studenten& Studenten :: operator=(const Studenten & orig)
{
 if ( &orig != this )
  {
    matrikel = orig.matrikel;
    skz      = orig.skz;
    pname    = orig.pname;
    pvorname = orig.pvorname;
  }
 
 return *this;
}

// ---------------------------------------------------------------------

ostream & operator<<(ostream  & s, const Studenten & orig)
{
 return s << orig.pvorname << " "   << orig.pname << " , "
          << orig.matrikel << " , " << orig.skz; 
} 
// ---------------------------------------------------------------------
 
void Studenten :: Print(ostream  & s)
{
  s << pvorname << " ";
  s <<    pname << " , ";
  s << matrikel << " , " << skz << endl;
  return;
}
 
 
 
 
 
 
 
 
 
