//	studs.cpp

#include <iostream>
#include <cstring>
#include "studs.hpp"
using namespace std;

// ---------------------------------------------------------------------

Studenten :: Studenten()
{
 cout << "Standard-konstruktor" << endl;
 matrikel = skz = 0;

 pname = new char[1];
 pname[0] = '\0';
 pvorname_ = new char[1];
 pvorname_[0] = '\0';
}

// ---------------------------------------------------------------------

Studenten :: Studenten(const char vorname_[], const char name[], 
		  const long int  mat_nr,    const int  skz_nr)
{
 cout << "Parameter-konstruktor" << endl;
 matrikel = mat_nr;
 skz      = skz_nr;
 
 pname = new char[strlen(name)+1];
 strcpy(pname,name);
 pvorname_ = new char[strlen(vorname_)+1];
 strcpy(pvorname_,vorname_);
}

// ---------------------------------------------------------------------
//	Copy constructor will be applied only to uninitialized data
//	===> no deallocation of memory necessary

Studenten :: Studenten(const Studenten& orig)
{
 cout << "Copy-konstruktor" << endl;

 matrikel = orig.matrikel;
 skz      = orig.skz;

 pname = new char[strlen(orig.pname)+1];
 strcpy(pname,orig.pname);

 pvorname_ = new char[strlen(orig.pvorname_)+1];
 strcpy(pvorname_,orig.pvorname_);
}

// ---------------------------------------------------------------------

Studenten :: ~Studenten()
{
 delete [] pvorname_;
 delete [] pname;
 cout << "Destruktor " << endl;
}

// ---------------------------------------------------------------------
//	Assignment operator will be applied also to already initialized data
//	===> deallocation of memory may be necessary

Studenten& Studenten :: operator=(const Studenten & orig)
{
 if ( &orig != this )
  {
    delete [] pvorname_;
    delete [] pname;

    matrikel = orig.matrikel;
    skz      = orig.skz;

    pname = new char[strlen(orig.pname)+1];
    strcpy(pname,orig.pname);

    pvorname_ = new char[strlen(orig.pvorname_)+1];
    strcpy(pvorname_,orig.pvorname_);
  }

 return *this;
}

// ---------------------------------------------------------------------

ostream & operator<<(ostream  & s, const Studenten & orig)
{
 return s << orig.pvorname_ << " "   << orig.pname << " , "
          << orig.matrikel << " , " << orig.skz;
}

// ---------------------------------------------------------------------
 
// void Studenten :: Print(ostream  & s)
// {
//   s << pvorname_ << " ";
//   s <<    pname << " , ";
//   s << matrikel << " , " << skz << endl;
//   return;
// }
 
 
 
 
 
 
 
 
 
