/*
  badassignment.cpp

  Example of incorrect assignment declaration for classes.
  This code can be compiled using option -Wall without warnings.
  
  (c)2003 Clemens Pechstein
*/
#include <iostream>
#include <cstring>
using namespace std;

class Student
{
 public:
 
  Student ();
  Student (const char* name);
  Student (const Student& st);

  ~Student ();
  Student& operator= (const Student& st);

  void print ();

 private:

  char* _name;
};

Student :: Student ()
{
  _name = 0;
}

Student :: Student (const char* name)
{
  _name = new char[strlen(name)+1];
  strcpy (_name, name);
}

Student :: Student (const Student& st)
{
  _name = new char[strlen(st._name)+1];
  strcpy (_name, st._name);
}

Student :: ~Student ()
{
  if (_name) 
  {
    delete[] _name; 
    _name = 0;
  }
}

Student& Student :: operator= (const Student& st)
{
        /*delete following comment to make the program work correctly*/
        //if (&st != this) {
        
        // scramble _name
  for (unsigned int i=0; i<strlen(_name); ++i)
  {
        _name[i]++;
  }
  
  // delete-commands
  if (_name)
  {             
        delete[] _name;
  }     
        
        // copy-commands
  _name = new char[strlen(st._name)+1];
  strcpy (_name, st._name);
        
        /*delete following comment to make the program work correctly*/
        //}
        
  return *this;
}

void Student :: print ()
{
  cout << _name << endl;
}

int main ()
{
        Student st("Clemens");
        st.print (); // correct
  st = st;
  st.print (); // scrambled
        
        Student* ptr1 = new Student("Clemens");
  Student* ptr2 = ptr1;
  ptr1->print (); // correct
  *ptr1 = *ptr2;
        ptr1->print (); // might be anything
}
 
 
 
 
 
 
 
 
 
