//	bung 6 - Aufgabe C
//				Funktionsauswahl aus Bisect6.cc
//	g++ u6C.cc 

#include <iostream.h>
#include <math.h>
//			Include my own declarations
const double EPS = 1e-6;		// accuracy constant

double f(const double x)		// declaration and
  { return sin(x) - 0.5*x ; }		//   definition of function f(x)
double df(const double x)		//   derivative
  { return cos(x)-0.5; }

double g(const double x)		// declaration and
  { return -(x-1.234567)*(x+0.987654) ; }//   definition of function g(x)
double dg(const double x)		//   derivative
  { return -2*x+1.23456-0.987654; }

double h(const double x)		// declaration and
  { return 3.0 - exp(x) ; }		//   definition of function h(x)
double dh(const double x)		//   derivative
  { return -exp(x); }

double t(const double x)		// declaration and
  { return 1-x*x ; }			//   definition of function t(x)
double dt(const double x)		//   derivative
  { return -2*x; }

double NewtonSolve(const double &x0, double (* const func)(double), 
		 double (* const dfunc)(double), const double eps=1e-6);
double NewtonSolve2(const double &x0, double (* const func)(double), 
		 double (* const dfunc)(double), const double eps=1e-6);

main()
{
 char   choice;
 double (*ff)(double), (*dff)(double);
 double x,x0;
 
 
 cout << endl;
 cout << " Determine point of zero in by Newton iteration " << endl;

 cout << "  f(x) :=  sin(x) - x/2" << endl;
 cout << "  g(x) := (1.234567-x)*(x+0.987654)" << endl;
 cout << "  h(x) :=  3.0 - exp(x)" << endl;
 cout << "  t(x) :=  1-x*x" << endl;

 cout << endl << "Which function do you prefer ? "; 
 cin  >> choice;
 
 switch (choice)
 {
   case 'f':  ff = f; dff = df; break;
   case 'g':  ff = g; dff = dg; break;
   case 't':  ff = t; dff = dt; break;
   default: 
   	choice = 'h';
	cout <<  " no correct choice. h(x) is used." << endl;
   case 'h':  ff = h; dff = dh; break;
 }
 
 cout << endl << "x value for  start: "; 
 cin  >> x0;
 
 x = NewtonSolve(x0, ff, dff, EPS);
 cout << "A:  f(" << x << ") = " << ff(x) << endl;

 x = NewtonSolve2(x0, ff, dff, EPS);
 cout << "B:  f(" << x << ") = " << ff(x) << endl; 
 
 return 0;
}


double NewtonSolve(const double &x0, double (* const func)(double), 
		 double (* const dfunc)(double), const double eps)
{
 double fx, dx, x;
 int    k;
 
 x  = x0;
 fx = func(x);
 dx = dfunc(x);
 k  = 0;
 while (fabs(fx) > eps && fabs(dx)>eps*eps) 
 {
   k++;
   x  = x - fx/dx;
   fx = func(x);
   dx = dfunc(x);
 }

 if (fabs(dx)<eps*eps) 
  {
   cout << "WARNING: Derivativ is too small: " << dx << endl;
   cout << "I stopped the iteration" << endl;
  }

 return x;
}

double NewtonSolve2(const double &x0, double (* const func)(double), 
		 double (* const dfunc)(double), const double eps)
{
 double fx, dx, xnew, xold;
 int    k;
 
 xnew = x0;
 xold = xnew + 1.0;
 fx = func(xnew);
 dx = dfunc(xnew);
 k  = 0;
 while (fabs(xnew-xold) > eps && fabs(dx)>eps*eps) 
 {
   k++;
   xold = xnew;
   xnew  = xold - fx/dx;
   fx = func(xnew);
   dx = dfunc(xnew);
 }

 if (fabs(dx)<eps*eps) 
  {
   cout << "WARNING: Derivativ is too small: " << dx << endl;
   cout << "I stopped the iteration" << endl;
  }

 return xnew;
}
